; File: out1.asm
;
; 
include \masm32\include\masm32rt.inc

InputXYZ        proto :DWORD,:DWORD,:DWORD
CvStrInt        proto :DWORD,:DWORD
; 
.data
; ######################################################################
align   4
_NumberX        dd ?
_NumberY        dd ?
_NumberZ        dd ?

align   4
_OutBuffer      db 180 dup (0)
;------------------------------------
_captionX       db "Input X", 0
_captionY       db "Input Y", 0
_captionZ       db "Input Z", 0
;------------------------------------
_StringX        db 60 dup (?)
_StringY        db 60 dup (?)
_StringZ        db 60 dup (?)
;------------------------------------

.data?
_hInstance      dd ?
;------------------------------------------------------------------------------
; It inputs 3 numbers. The ascci codes we type go to _StringX, then to _StringY
; and _StringZ. I want only numbers like "111", and "222", and "333"
;
; OutputXYZ should give: "111 X + 222 Y + 333 Z",0
;
; but it gives me: "111 X + 222 Y" and never 333 Z. Where is the bug ?
;
; Anyone can help me ?
; Thanks
; RuiLoureiro
; 
.code
start:
            invoke  GetModuleHandle, 0              
            mov     _hInstance, eax            ;return value in eax=handle of program

            call    main
            invoke  ExitProcess, 0   
;...................................................
main        proc

            invoke  InputXYZ, addr _NumberX, addr _captionX, addr _StringX
            jc      _Emain
            ;
            invoke  InputXYZ, addr _NumberY, addr _captionY, addr _StringY
            jc      _Emain            
            ;
            invoke  InputXYZ, addr _NumberZ, addr _captionZ, addr _StringZ 
            jc      _Emain                       

            call    OutputXYZ
            ;print   offset _OutBuffer
            invoke  StdOut, offset _OutBuffer
            
            print   chr$( 13, 10 )


            ;
            ; Input error
            ; ----------
_Emain:     print   chr$(" Exit ", " Exit ")            
            inkey
            ret
main        endp 
; ####################################################################################
; Output:
;           clc:    accepted
;
;           stc:    rejected
;
;
InputXYZ        proc    pXYZ:DWORD, pCaption:DWORD, pBuf:DWORD
                LOCAL   Buffer[60]:BYTE
                ;
                push    esi
                push    edi
                ;
                ;
                lea     esi, Buffer
                invoke  GetTextInput, NULL, _hInstance, NULL, pCaption,
                                      NULL, esi                             
                ;  
                mov     edi, pBuf                                                                   
                xor     ecx, ecx
                xor     ebx, ebx                    ; 0=+  1=-
                ;
                xor     edx, edx
_iInputXYZ:     movzx   eax, byte ptr [esi + edx]
                inc     edx
                ;
                cmp     al, 0
                je      _aInputXYZ 
                ;                
                cmp     al, 20h
                je      _iInputXYZ
                ;
                cmp     al, "-"
                je      @F
                ;                             
                cmp     al, "+"
                je     _nInputXYZ
                ;
                cmp     al, "0"
                jb      _eInputXYZ
                ;
                cmp     al, "9"
                ja      _eInputXYZ
                jbe     _nInputXYZ0
;++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
@@:             mov     ebx, 1
                je      _nInputXYZ
                ;
_nInputXYZ0:    mov     byte ptr [edi + ecx], al
                inc     ecx
                ;
_nInputXYZ:     movzx   eax, byte ptr [esi + edx]
                inc     edx
                ;
                cmp     al, 0
                je      _aInputXYZ 
                ;                
                cmp     al, 20h
                je      _nInputXYZ
                ;
                cmp     al, "0"
                jb      _eInputXYZ
                ;
                cmp     al, "9"
                jbe      _nInputXYZ0
                ja      _eInputXYZ
                ;     
_aInputXYZ:     cmp     ecx, 0
                je      _eInputXYZ                  ; reject
                ;
                ; convert
                ; -------  
                mov     byte ptr [edi + ecx], 0
                invoke  CvStrInt, edi, ebx
                ;
                mov     edx, pXYZ
                mov     dword ptr [edx], eax
                ;
                clc
                pop     edi
                pop     esi
                ret
                ;
_eInputXYZ:     stc
                pop     edi
                pop     esi
                ret
InputXYZ        endp
; ----------------------------------------------------------------------------------------------
; Output:
;           EAX     - number
;           ECX     = 0 +
;                   = 1 -
;
CvStrInt        proc    pBuf:DWORD, Sign:DWORD

                xor      eax, eax
                mov      edx, pBuf

                sub      edx, 1
                ;
@@:             add      edx, 1
                mov      al, [edx]
                add      edx, 1
   
                xor     ecx, ecx
                ;
@@:             sub     al,"0"                  
                jc      @F
                ;
                lea     ecx, [ecx + ecx*4]      
                lea     ecx, [eax + ecx*2]
                ;
                mov     al, [edx]
                add     edx, 1
                jmp     @B
                ;
@@:             mov     eax, ecx

                mov     ecx, Sign
                shr     ecx, 1
                jnc     @F
                ;
                neg     eax
                ;
@@:             ret
CvStrInt        endp
; 
OutputXYZ       proc
                push    esi
                push    edi
                ;
                cld
                mov     edi, offset _OutBuffer
                mov     esi, offset _StringX
                ;
_OutputXYZ1:    movzx   eax, byte ptr [esi]
                inc     esi
                ;
                cmp     al, 0
                je      _OutputXYZ2
                ;
                stosb
                ;mov     byte ptr [edi], al
                ;inc     edi
                jmp     _OutputXYZ1
                
_OutputXYZ2:    mov     eax, "  X " 
                stosd
                mov     byte ptr [edi], "+"
                inc     edi                
;....................................................
                mov     esi, offset _StringY
                ;
_OutputXYZ3:    movzx   eax, byte ptr [esi]
                inc     esi
                cmp     al, 0
                je      _OutputXYZ4
                ;
                stosb
                ;mov     byte ptr [edi], al
                ;inc     edi
                jmp     _OutputXYZ3
                
_OutputXYZ4:    mov     eax, " Y " 
                stosd
                mov     byte ptr [edi], "+"
                inc     edi                
;.....................................................
                mov     esi, offset _StringZ
                ;
_OutputXYZ5:    movzx   eax, byte ptr [esi]
                inc     esi
                ;
                cmp     al, 0
                je      _OutputXYZ6
                ;
                ;mov     byte ptr [edi], al
                ;inc     edi
                stosb
                ;##########################
                ;    THIS IS TO TEST
                ;##########################
                print   chr$( "HERE  " )
                print   offset _OutBuffer
                print   chr$(13, 10)                        
                
                inkey
                ;##########################

                jmp     _OutputXYZ5
                

_OutputXYZ6:    mov     eax, " Z  " 
                stosd
                mov     byte ptr [edi], 0 
                
                pop     edi
                pop     esi
                ret
OutputXYZ       endp
; 
end   start

















